-------------------------------------------------
-- Eternity alpha 0.5
-- Licence: GPL
-- Copyright (c) 2011 Caldas Lopes aka Linux-man
-------------------------------------------------

laser = class('laser')

function laser:initialize(parent, n, position, quant)
	self.p = parent
	self.n = n
	self.position = position
	self.quant = quant
	if n == 'Laser Mk I' then 
		self.gun_delta = 0.3
		self.gun_pulse = 0.3
		self.gun_range = 2000
		self.gun_power = 1
		self.color = {255, 0, 0, 255}
	elseif n == 'Laser Mk II' then 
		self.gun_delta = 0.3
		self.gun_pulse = 0.3
		self.gun_range = 4000
		self.gun_power = 1
		self.dist = gun_range
		self.color = {255, 255, 128, 255}
	elseif n == 'Laser Mk III' then 
		self.gun_delta = 0.3
		self.gun_pulse = 0.3
		self.gun_range = 8000
		self.gun_power = 1
		self.color = {255, 255, 0, 255}
	elseif n == 'Mining Laser' then 
		self.gun_delta = 0.2
		self.gun_pulse = 0.5
		self.gun_range = 500
		self.gun_power = 1
		self.color = {0, 128, 128, 255}
	end
	self.dist = gun_range
end

function laser:fire()
	if self.p.gun_charge < self.gun_pulse then return end
	self.p.firing = 10
	self.p.gun_delta = self.gun_delta
	self.p.gun_pulse = self.gun_pulse
	self.p.gun_charge = self.p.gun_charge - self.gun_pulse
	if self.position == 'front' then self.laser_angle = self.p.angle
	elseif self.position == 'rear' then self.laser_angle = self.p.angle + math.pi
	elseif self.position == 'left' then self.laser_angle = self.p.angle - math.pi / 2
	elseif self.position == 'right' then self.laser_angle = self.p.angle + math.pi / 2
	end
	self.dist = self.gun_range
	for n = self.p.off * self.p.scale + 1 , self.gun_range, 8 do
		for _,o in pairs(u.obj) do
			if (o.pos-self.p.pos):len2() < self.gun_range^2 then
				if (vector(self.p.pos.x + math.cos(self.laser_angle) * n, self.p.pos.y + math.sin(self.laser_angle) * n) - o.pos):len2() < (o.off * o.scale)^2 then
					self.dist = n
					o:hit(self.gun_power * (self.gun_range - (o.pos-self.p.pos):len()) / self.gun_range)
					break
				end
			end
		end
		if self.dist < self.gun_range then break end
	end
end

function laser:draw()
	for n = self.p.off + 1, self.dist, 2 / u.scale do
		love.graphics.setColor(self.color[1] ,self.color[2], self.color[3], 255 - n * 255 / self.gun_range )
		love.graphics.point(self.p.pos.x + math.cos(self.laser_angle) * n, self.p.pos.y + math.sin(self.laser_angle) * n)
	end
	if self.dist < self.gun_range then
		for n = 1, 10 do
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.point(self.p.pos.x + math.cos(self.laser_angle) * self.dist + (rnd:random(20) - 10), self.p.pos.y + math.sin(self.laser_angle) * self.dist + (rnd:random(20) - 10))
		end
	end
	self.p.firing = self.p.firing - 1
end

phaser = class('phaser')

function phaser:initialize(parent, n, position, quant)
	self.p = parent
	self.n = n
	self.position = position
	self.quant = quant
	if n == 'Phaser Mk I' then 
		self.gun_delta = 0.3
		self.gun_pulse = 0.5
		self.gun_power = 1
		self.color = {255, 0, 0, 255}
	elseif n == 'Phaser Mk II' then 
		self.gun_delta = 0.3
		self.gun_pulse = 0.3
		self.gun_power = 1
		self.color = {255, 255, 0, 255}
	elseif n == 'Phaser Mk III' then 
		self.gun_delta = 0.5
		self.gun_pulse = 0.2
		self.gun_power = 2
		self.color = {255, 255, 255, 255}
	end
end

function phaser:fire()
	if self.p.gun_charge < self.gun_pulse then return end
	self.p.firing = 0
	self.p.gun_delta = self.gun_delta
	self.p.gun_pulse = self.gun_pulse
	self.p.gun_charge = self.p.gun_charge - self.gun_pulse
	if self.position == 'front' then lpos, lvel = self.p.pos + self.p.dir * self.p.off * 1.1, self.p.v + self.p.dir * 1000
	elseif self.position == 'rear' then lpos, lvel = self.p.pos - self.p.dir * self.p.off * 1.1, self.p.v - self.p.dir * 1000
	elseif self.position == 'left' then lpos, lvel = self.p.pos - self.p.dir:perpendicular() * self.p.off * 1.1, self.p.v - self.p.dir:perpendicular() * 1000
	elseif self.position == 'right' then lpos, lvel = self.p.pos + self.p.dir:perpendicular() * self.p.off * 1.1, self.p.v + self.p.dir:perpendicular() * 1000
	end
	if self.quant == 1 or self.quant == 3 then
		table.insert(u.shots, shot(lpos, lvel, self.gun_power, self.color))
	end
	if self.quant > 1 then
		table.insert(u.shots, shot(lpos +(self.p.pos - lpos):normalized():perpendicular() * self.p.off / 2, lvel, self.gun_power, self.color))
		table.insert(u.shots, shot(lpos -(self.p.pos - lpos):normalized():perpendicular() * self.p.off / 2, lvel, self.gun_power, self.color))
	end
end

function phaser:draw()
end

shot = class('shot')

function shot:initialize(pos, v, gun_power, color)
	self.pos = pos
	self.v = v
	self.gun_power = gun_power
	self.img = phaser_img
	self.off = self.img:getHeight()/2
	self.color = color
	self.destroyed = false
	self.draw_dist = 10000^2
	self.update_dist = 110000^2
	self.destroy_dist = 100000^2

	self.engine = love.graphics.newParticleSystem(eng_img, 25)
	self.engine:setLifetime(0.25)
	self.engine:setEmissionRate(100)
	self.engine:setSpeed(100, 200)
	self.engine:setSize(0.2, 0.5)
	self.engine:setColor(255, 255, 255, 255)
	self.engine:setParticleLife(0.25)
	self.engine:setSpread(math.pi * 2)
	self.engine:stop()
end

function shot:update(dt)
	if (player.pos - self.pos):len2()> self.destroy_dist then self:destroy() end
	if (player.pos - self.pos):len2()> self.update_dist then return end
	if self.destroyed == false then
		self.pos = self.pos + self.v * dt
		for _,o in pairs(u.obj) do
			if o.destroyed == false and (o.pos-self.pos):len2() < (o.off * o.scale)^2 then
				self:destroy()
				o:hit(self.gun_power)
			end
		end
		for _,o in pairs(u.planets) do
			if o.destroyed == false and (o.pos-self.pos):len2() < (o.off * o.scale)^2 then
				self:destroy()
			end
		end
	end
	self.engine:update(dt)
end

function shot:draw()
	if (player.pos - self.pos):len2() > self.draw_dist then return end
	love.graphics.setColor(self.color)
	if self.destroyed == false then love.graphics.draw(self.img, self.pos.x, self.pos.y, self.angle, self.scale, self.scale, self.off, self.off) end
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(self.engine, self.pos.x, self.pos.y)
end

function shot:destroy()
	if self.destroyed == false then
		self.engine:start()
		self.destroyed = true
	end
end

missile = class('missile', shot)

function missile:initialize(pos, v, dir, target, gun_power, color)
	shot.initialize(self, pos, v, gun_power, color)
	self.target = target
	self.turn = 0.5
	self.a_max = 200
	self.a = self.a_max
	self.dir = dir
	self.angle = theta(self.dir:unpack())
	self.img = missile_img
	self.off = self.img:getHeight()/2
end

function missile:update(dt)
	if self.target then self:autopilot_0(dt) end
	self.v = self.v + self.a * self.dir * dt
	shot.update(self, dt)
end

function missile:autopilot_0(dt)
	self.angle = theta(self.dir:unpack())
	local destiny = self.target.pos
	local angle = theta((destiny - self.pos):unpack())
	if math.abs(angle-self.angle) < self.turn * dt then
		self.angle = angle
		self.v = self.v:projectOn(self.pos - destiny)
	elseif ((math.abs(angle-self.angle)<math.pi and angle-self.angle>0)
	or (math.abs(angle-self.angle)>math.pi and angle-self.angle<0))
	then self.angle = self.angle + (self.turn * dt)
	else self.angle = self.angle - (self.turn * dt) end
	self.dir = vector(math.cos(self.angle), math.sin(self.angle))
end
