-------------------------------------------------
-- Eternity alpha 0.5
-- Licence: GPL
-- Copyright (c) 2011 Caldas Lopes aka Linux-man
-------------------------------------------------

function draw_menu()
	local bx
	local menu = u.view.menu
	if menu == 'cockpit' then bx = -400
	elseif menu == 'scanner' then bx = -300
	elseif menu == 'galaxy' then bx = -200
	elseif menu == 'market' then bx = -100
	elseif menu == 'equipment' then bx = 0
	elseif menu == 'ships' then bx = 100
	elseif menu == 'billboard' then bx = 200
	elseif menu == 'options' then bx = 300
	end
	love.graphics.setColor(128, 128, 128, 128)
	love.graphics.rectangle('fill', w / 2 + bx, 0, 100, 40)
	love.graphics.setFont(frontier2)
	love.graphics.setLine(2, 'rough')
	love.graphics.setColor(255 ,255, 255, 255)
	love.graphics.rectangle('line',  0, 0, w, h)
	love.graphics.rectangle('line', w / 2 - 400, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 - 300, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 - 200, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 - 100, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 + 000, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 + 100, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 + 200, 0, 100, 40)
	love.graphics.rectangle('line', w / 2 + 300, 0, 100, 40)
	love.graphics.printf('Cockpit', w / 2 - 400, 13, 100, 'center')
	love.graphics.printf('Scanner', w / 2 - 300, 13, 100, 'center')
	love.graphics.printf('Galaxy', w / 2 - 200, 13, 100, 'center')
	love.graphics.printf('Market', w / 2 - 100, 13, 100, 'center')
	love.graphics.printf('Equipment', w / 2 - 000, 13, 100, 'center')
	love.graphics.printf('Ships', w / 2 + 100, 13, 100, 'center')
	love.graphics.printf('Billboard', w / 2 + 200, 13, 100, 'center')
	love.graphics.printf('Options', w / 2 + 300, 13, 100, 'center')
	love.graphics.setLine(1, 'rough')
	love.graphics.setFont(frontier)
end

function mousepressed_menu(x, y, button)
	if player.docked and y < 40 and button == 'l' then
		if x > w / 2 - 400 and x < w / 2 - 300 then u.view = cockpit.create()
		elseif x > w / 2 - 300 and x < w / 2 - 200 then u.view = scanner.create()
		elseif x > w / 2 - 200 and x < w / 2 - 100 then u.view = galaxy.create()
		elseif x > w / 2 - 100 and x < w / 2 - 000 then u.view = market.create()
		elseif x > w / 2 - 000 and x < w / 2 + 100 then u.view = equipment.create()
		elseif x > w / 2 + 100 and x < w / 2 + 200 then u.view = ships.create()
		elseif x > w / 2 + 200 and x < w / 2 + 300 then u.view = billboard.create()
		elseif x > w / 2 + 300 and x < w / 2 + 400 then u.view = options.create()
		end
		return true
	end
	return false
end

cockpit = {}
cockpit.__index = cockpit

function cockpit.create()
	local temp = {}
	setmetatable(temp, cockpit)
	temp.menu = 'cockpit'
	return temp
end

function cockpit:update(dt)

end

function cockpit:draw()
	local x0 = (w - 800) / 2
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.draw(framebuffer)
	love.graphics.setLine(2, 'rough')
	love.graphics.setColor(255 ,255, 255, 255)
	love.graphics.line(w / 2 + 100, h - 100, w - x0, h - 100, w - x0, h, x0, h, x0, h - 100, w / 2 - 100, h - 100)
	love.graphics.setLine(1, 'rough')
	love.graphics.circle('line', w/2, h - 100, 100, 32)
	love.graphics.setPoint(3, 'rough')
	love.graphics.point(w / 2, h - 100)
	love.graphics.setColor(255 ,255, 255, 64)
	love.graphics.line(w / 2, h - 100, w / 2 + player.v:normalized().x * 100, h - 100 + player.v:normalized().y * 100)
	love.graphics.setColor(255 ,255, 255, 255)

	love.graphics.setPoint(2, 'rough')
	local caption = ''
	local d, dx, dy, dr = 0, 0, 0, 0
	if player.e_scanner > 0 then
		for _,o in pairs(u.obj) do
			dx, dy = (o.pos.x - player.pos.x) / u.hud_scale, (o.pos.y - player.pos.y) / u.hud_scale
			d = math.sqrt(dx * dx + dy * dy)
			if d < 1 and o.type ~= 'player' then
				if o.type == 'ship' then love.graphics.setColor(255 ,128, 128, 255) else love.graphics.setColor(255 ,255, 255, 255) end
				love.graphics.point(dx * 100 + w / 2, dy * 100 + h - 100)
				if u.scan_mode == 3 then caption = o.name
				elseif u.scan_mode == 4 then caption = string.format("%.2f", d * u.hud_scale / 100000) end
				love.graphics.print(caption, dx * 100 + w / 2, dy * 100 + h - 110)
			end
		end
		love.graphics.setColor(255 ,255, 0, 255)
		for _,o in pairs(u.shots) do
			dx, dy = (o.pos.x - player.pos.x) / u.hud_scale, (o.pos.y - player.pos.y) / u.hud_scale
			d = math.sqrt(dx * dx + dy * dy)
			if d < 1 then love.graphics.point(dx * 100 + w / 2, dy * 100 + h - 100) end
		end
		if player.target then
			love.graphics.setColor(255 ,0, 0, 255)
			dx, dy = (player.target.pos.x - player.pos.x) / u.hud_scale, (player.target.pos.y - player.pos.y) / u.hud_scale
			d = math.sqrt(dx * dx + dy * dy)
			if d < 1 then love.graphics.point(dx * 100 + w / 2, dy * 100 + h - 100) end
		end
		caption = ''
	end
	for n,o in pairs(u.planets) do
		local mode
		if n == 0 then
			love.graphics.setColor(255 ,255, 255, 255)
			mode ='fill'
		else
			love.graphics.setColor(128 ,128, 255, 255)
			mode = 'line'
		end
		dx, dy, dr = (o.pos.x - player.pos.x) / u.hud_scale, (o.pos.y - player.pos.y) / u.hud_scale, o.scale * o.off / u.hud_scale
		d = math.sqrt(dx * dx + dy * dy)
		if d > 1 then dx, dy, dr = dx / d, dy / d , 0.03 end
		love.graphics.circle(mode, dx * 100 + w / 2, dy * 100 + h - 100, dr * 100)
		if u.scan_mode == 1 then caption = o.name
		elseif u.scan_mode == 2 then caption = string.format("%.2f", d * u.hud_scale / 100000) end
		love.graphics.print(caption, dx * 100 + w / 2, dy * 100 + h - 115)
	end
	caption = ''
	love.graphics.setColor(0 ,255, 0, 255)
	for n,o in pairs(player.destiny) do
		dx, dy = (o.x - player.pos.x) / u.hud_scale, (o.y - player.pos.y) / u.hud_scale
		d = math.sqrt(dx * dx + dy * dy)
		if d > 1 then dx, dy = dx / d, dy / d end
		love.graphics.point(dx * 100 + w / 2, dy * 100 + h - 100)
		if u.scan_mode == 1 then caption = n
		elseif u.scan_mode == 2 then caption = string.format("%.2f", d * u.hud_scale / 100000) end
		love.graphics.print(caption, dx * 100 + w / 2, dy * 100 + h - 110)
	end
	love.graphics.setColor(255 ,255, 255, 255)
	love.graphics.print('Scanner', x0+200, h - 100 + 25)
	love.graphics.printf(u.hud_scale, x0+160, h - 100 + 25, 30, 'right')
	if player.docked then draw_menu() end
end

function cockpit:keyreleased(key, unicode)
	if key == 'z' then u.scale = math.min(1, u.scale * 2)
	elseif key == 'x' then u.scale = math.max(0.0625, u.scale / 2) end
end

function cockpit:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
end

scanner = {}
scanner.__index = scanner

function scanner.create()
	local temp = {}
	setmetatable(temp, scanner)
	temp.menu = 'scanner'
	return temp
end

function scanner:update(dt)

end

function scanner:draw_planet(planet_n)
	local planet = u.planets[planet_n]
	love.graphics.setLine(2, 'rough')
	love.graphics.setFont(frontier2)
	if planet_n == 0 then
		love.graphics.setColor(planet.color)
		love.graphics.circle("fill", w , h / 2, planet.scale * h / 3, 90)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.print('Sun', 30, 315)
		love.graphics.print('Name: '..u.ss_name, 30, 335)
		love.graphics.print('Diameter: '..math.floor(planet.scale * planet.off * 2)..' km', 30, 355)
	else
		love.graphics.setColor(planet.color)
		love.graphics.draw(planet.img, w * 3 / 4, h / 2, planet.angle, planet.scale / 3, planet.scale / 3, planet.off, planet.off)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.print('Planet', 30, 315)
		love.graphics.print('Name: '..planet.name, 30, 335)
		love.graphics.print('Coordinates: '..math.floor(planet.pos.x)..', '..math.floor(planet.pos.y), 30, 355)
		love.graphics.print('Diameter: '..math.floor(planet.scale * planet.off * 2)..' km', 30, 375)
		love.graphics.printf( planet.comment, 30, 395, 220, 'left' )
	end
	love.graphics.line(100, 320, 260, 320, 260, 495, 20, 495, 20, 320, 25, 320)
	love.graphics.line(100, 60, 260, 60, 260, 300, 20, 300, 20, 60, 25, 60)
	love.graphics.print('System', 30, 55)
	love.graphics.print('Name: '..u.ss_name, 30, 75)
	love.graphics.print('Galactic Coord.: '..math.floor(u.ss_pos.x)..', '..math.floor(u.ss_pos.y), 30, 95)
	love.graphics.print('Planets: '..u.planets_n, 30, 114)
	love.graphics.print('Specie: '..u.specie, 30, 135)
	love.graphics.print('Government: '..govs[u.gov], 30, 155)
	love.graphics.print('Economy: '..econs[u.econ], 30, 175)
	love.graphics.print('Technology Level: '..u.tech, 30, 195)
	love.graphics.print('Population: '..u.pop..' billions', 30, 215)
	love.graphics.print('Productivity: '..u.prod..' units/year', 30, 235)
	if u.corr == 1 then love.graphics.print('Political correct: Yes', 30, 255)
	else love.graphics.print('Political correct: No', 30, 255) end
end

function scanner:draw()
	local x0 = (w - 800) / 2
	local scale = math.min(w, h) * u.scanner_scale
	local dx, dy, dr, d = 0, 0, 0, 0
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.rectangle('fill', 0, 0, w, h)
	if u.show_planet > -1 then self:draw_planet(u.show_planet) end
	love.graphics.setFont(frontier)
	love.graphics.setColor(255 ,255, 255, 32)
	love.graphics.line(w / 2, h / 2, w / 2 + player.v:normalized().x * 10000, h / 2 + player.v:normalized().y * 10000)
	love.graphics.setColor(255 ,255, 255, 255)
	love.graphics.setLine(1, 'rough')
	love.graphics.setPoint(3, 'rough')
	love.graphics.point(w / 2, h / 2)
	love.graphics.setPoint(1, 'smooth')
	local caption = ''
	for _,o in pairs(u.planets) do
		local mode
		if _ == 0 then
			love.graphics.setColor(255, 255, 255, 255)
			mode ='fill'
		else
			love.graphics.setColor(128, 128, 255, 255)
			mode = 'line'
		end
		dx, dy, dr = (o.pos.x - player.pos.x) / 100000 , (o.pos.y - player.pos.y) / 100000, o.scale * o.off / 100000
		d = math.sqrt(dx * dx + dy * dy)
		love.graphics.circle(mode, dx * scale + w / 2, dy * scale + h / 2, math.max(4, dr * scale))
		if u.scan_mode == 1 then caption = o.name
		elseif u.scan_mode == 2 then caption = string.format("%.2f", d) end
		love.graphics.print(caption, dx * scale + w / 2, dy * scale + h / 2 - math.max(4, dr * scale) -15)
	end

	love.graphics.setColor(255, 255, 0, 255)
	for _,o in pairs(u.ast_fields) do
		dx, dy, dr = (o.pos.x - player.pos.x) / 100000 , (o.pos.y - player.pos.y) / 100000, 2
		love.graphics.circle('line', dx * scale + w / 2, dy * scale + h / 2, math.max(8, 2 * scale))
	end
	love.graphics.setPoint(2, 'rough')
	caption = ''
	for _,o in pairs(u.obj) do
		dx, dy = (o.pos.x - player.pos.x) / 100000 , (o.pos.y - player.pos.y) / 100000
		d = math.sqrt(dx * dx + dy * dy)
		if d < u.scanner_range and o.type ~= 'player' then
			if o.type == 'ship' then love.graphics.setColor(255 ,128, 128, 255) else love.graphics.setColor(255 ,255, 255, 255) end
			love.graphics.point(dx * scale + w / 2, dy * scale + h / 2)
			if u.scan_mode == 3 then caption = o.name
			elseif u.scan_mode == 4 then caption = string.format("%.2f", d) end
			love.graphics.print(caption, dx * scale + w / 2, dy * scale + h / 2 - 10)
		end
	end
	love.graphics.setColor(255 ,255, 0, 255)
	for _,o in pairs(u.shots) do
		dx, dy = (o.pos.x - player.pos.x) / 100000 , (o.pos.y - player.pos.y) / 100000
		d = math.sqrt(dx * dx + dy * dy)
		if d < u.scanner_range then love.graphics.point(dx * scale + w / 2, dy * scale + h / 2) end
	end
	if player.target then
		love.graphics.setColor(255 ,0, 0, 255)
		dx, dy = (player.target.pos.x - player.pos.x) / 100000 , (player.target.pos.y - player.pos.y) / 100000
		d = math.sqrt(dx * dx + dy * dy)
		if d < u.scanner_range then love.graphics.point(dx * scale + w / 2, dy * scale + h / 2) end
	end

	caption = ''
	love.graphics.setColor(0 ,255, 0, 255)
	for n,o in pairs(player.destiny) do
		dx, dy = (o.x - player.pos.x) / 100000 , (o.y - player.pos.y) / 100000
		d = math.sqrt(dx * dx + dy * dy)
		if u.scan_mode == 1 then caption = n
		elseif u.scan_mode == 2 then caption = string.format("%.2f", d) end
		love.graphics.circle('fill', dx * scale + w / 2, dy * scale + h / 2, 2)
		love.graphics.print(caption, dx * scale + w / 2, dy * scale + h / 2 - 20)
	end

	love.graphics.setColor(255 ,255, 255, 255)
	love.graphics.print('Scanner', x0+200, h - 100 + 25)
	love.graphics.printf(string.format("%.3f",u.scanner_scale), x0+160, h - 100 + 25, 30, 'right')
	if player.docked then draw_menu() end
end

function scanner:keyreleased(key, unicode)
	if key == 'z' then u.scanner_scale = math.min(1, u.scanner_scale * 1.5)
	elseif key == 'x' then u.scanner_scale = math.max(0.001, u.scanner_scale / 1.5) end
end

function scanner:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
	local scale = math.min(w, h) * u.scanner_scale
	local dx, dy, dr, d = 0, 0, 0, 0
	if button == 'l' then
		for n,o in pairs(u.planets) do
			dx, dy, dr = (o.pos.x - player.pos.x) / 100000 , (o.pos.y - player.pos.y) / 100000, o.scale * o.off / 100000
			d = math.sqrt(dx * dx + dy * dy)
			dx, dy, dr = dx * scale + w / 2, dy * scale + h / 2,  math.max(4, dr * scale)
			if (x-dx)^2 + (y-dy)^2 < dr * dr then u.show_planet = n end
		end
		if u.show_planet == -1 then table.insert(player.destiny, player.pos + vector((x - w / 2) * 100000 / (math.min(w, h) * u.scanner_scale), (y - h / 2) * 100000 / (math.min(w, h) * u.scanner_scale))) end
	elseif button == 'r' then
		u.show_planet = -1
		for n,o in pairs(player.destiny) do
			dx, dy = (o.x - player.pos.x) / 100000 , (o.y - player.pos.y) / 100000
			d = math.sqrt(dx * dx + dy * dy)
			dx, dy, dr = dx * scale + w / 2, dy * scale + h / 2, 12
			if (x-dx)^2 + (y-dy)^2 < dr * dr then table.remove(player.destiny, n) end
		end
	end
end

galaxy = {}
galaxy.__index = galaxy

function galaxy.create()
	local temp = {}
	setmetatable(temp, galaxy)
	temp.galaxy_scale = 2.25
	temp.galaxy_dx = 0
	temp.galaxy_dy = 0
	temp.menu = 'galaxy'
	return temp
end

function galaxy:update(dt)

end

function galaxy:draw()
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.rectangle('fill', 0, 0, w, h)
	love.graphics.setPoint(1, 'smooth')
	local x, y
	for n = 1, #u.galaxy do
		x = self.galaxy_dx + (u.galaxy[n].ss_pos.x - u.galaxy[u.ss].ss_pos.x) * w / 400
		y = self.galaxy_dy + (u.galaxy[n].ss_pos.y - u.galaxy[u.ss].ss_pos.y) * h / 300
		while x < -w / 2 do x = x + w end while x > w / 2 do x = x - w end
		while y < -h / 2 do y = y + h end while y > h / 2 do y = y - h end
		x, y = x * self.galaxy_scale + w / 2, y * self.galaxy_scale + h / 2
		u.galaxy[n].x = x u.galaxy[n].y = y
		love.graphics.setColor(u.galaxy[n].color)
		love.graphics.setPoint(math.ceil(u.galaxy[n].scale * self.galaxy_scale) , 'smooth')
		love.graphics.point(x, y)
	end
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.line(u.galaxy[u.ss].x - 16, u.galaxy[u.ss].y, u.galaxy[u.ss].x + 16, u.galaxy[u.ss].y)
	love.graphics.line(u.galaxy[u.ss].x, u.galaxy[u.ss].y - 16, u.galaxy[u.ss].x, u.galaxy[u.ss].y + 16)
	love.graphics.circle('line', u.galaxy[u.ss].x, u.galaxy[u.ss].y, self.galaxy_scale * player.fuel * 20 * player.e_hyperspace / player.fuel_max * w / 400, 32) --  u.p.ss_distance  = u.fuel * 20 / (u.e_hyperspace * u.fuel_max)
	if u.ss_galaxy > 0 then
		local dx, dy
		love.graphics.setColor(255, 0, 0, 255)
		love.graphics.line(u.galaxy[u.ss_galaxy].x - 16, u.galaxy[u.ss_galaxy].y, u.galaxy[u.ss_galaxy].x + 16, u.galaxy[u.ss_galaxy].y)
		love.graphics.line(u.galaxy[u.ss_galaxy].x, u.galaxy[u.ss_galaxy].y - 16, u.galaxy[u.ss_galaxy].x, u.galaxy[u.ss_galaxy].y + 16)
		love.graphics.setLine(2, 'rough')
		love.graphics.setFont(frontier2)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.line(100, 60, 260, 60, 260, 300, 20, 300, 20, 60, 25, 60)
		love.graphics.print('System', 30, 55)
		love.graphics.print('Name: '..u.galaxy[u.ss_galaxy].ss_name, 30, 75)
		love.graphics.print('Galactic Coord.: '..math.floor(u.galaxy[u.ss_galaxy].ss_pos.x)..', '..math.floor(u.galaxy[u.ss_galaxy].ss_pos.y), 30, 95)
		love.graphics.print('Planets: '..u.galaxy[u.ss_galaxy].planets_n, 30, 114)
		love.graphics.print('Specie: '..u.galaxy[u.ss_galaxy].specie, 30, 135)
		love.graphics.print('Government: '..govs[u.galaxy[u.ss_galaxy].gov], 30, 155)
		love.graphics.print('Economy: '..econs[u.galaxy[u.ss_galaxy].econ], 30, 175)
		love.graphics.print('Technology Level: '..u.galaxy[u.ss_galaxy].tech, 30, 195)
		love.graphics.print('Population: '..u.galaxy[u.ss_galaxy].pop..' billions', 30, 215)
		love.graphics.print('Productivity: '..u.galaxy[u.ss_galaxy].prod..' units/year', 30, 235)
		if u.galaxy[u.ss_galaxy].corr == 1 then love.graphics.print('Political correct: Yes', 30, 255)
		else love.graphics.print('Political correct: No', 30, 255) end
		dx = u.galaxy[u.ss_galaxy].ss_pos.x - u.galaxy[u.ss].ss_pos.x
		dx = math.min(dx^2, (dx + 400)^2, (dx - 400)^2) 
		dy = u.galaxy[u.ss_galaxy].ss_pos.y - u.galaxy[u.ss].ss_pos.y
		dy = math.min(dy^2, (dy + 300)^2, (dy - 300)^2)
		u.ss_distance = math.sqrt(dx + dy)
		love.graphics.print('Distance: '..string.format("%.2f",u.ss_distance)..' ly', 30, 275)
	end
	if player.docked then draw_menu() end
end

function galaxy:keyreleased(key, unicode)
	if key == 'z' then self.galaxy_scale = math.min(7.5, self.galaxy_scale * 1.5)
	elseif key == 'x' then self.galaxy_scale = math.max(1, self.galaxy_scale / 1.5) end
	if not player.docked then return end
	if key == 'left' then self.galaxy_dx = self.galaxy_dx + 8
	elseif key == 'right' then self.galaxy_dx = self.galaxy_dx - 8
	elseif key == 'up' then self.galaxy_dy = self.galaxy_dy + 8
	elseif key == 'down' then self.galaxy_dy = self.galaxy_dy - 8 end
end

function galaxy:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
	if button == 'l' then
		if player.docked and y < 40 then return end
		local d = w^2
		for n,o in pairs(u.galaxy) do
			if (o.x - x)^2 + (o.y - y)^2 < d then
				d = (o.x - x)^2 + (o.y - y)^2
				u.ss_galaxy = n
			end
		end
	elseif button == 'r' then
		u.ss_galaxy = 0
	end
end

market = {}
market.__index = market

function market.create()
	local temp = {}
	setmetatable(temp, market)
	temp.menu = 'market'
	return temp
end

function market:update(dt)

end

function market:draw()
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.rectangle('fill', 0, 0, w, h)
	love.graphics.setLine(2, 'rough')
	love.graphics.setFont(frontier2)
	love.graphics.setColor(255, 255, 255, 255)
	local dx = 0
	love.graphics.rectangle('line', dx+20, 60, 241, 60)
	love.graphics.print('Cash', dx+30, 75)
	love.graphics.print('Cargo', dx+30, 95)
	love.graphics.printf(string.format("%.2f",player.cash), dx+140, 75, 100, 'right')
	love.graphics.printf(player.cargo_t..' / '..player.cargo_max, dx+140, 95, 100, 'right')
	dx = 260
	love.graphics.line(100+dx, 60, 260+dx, 60, 260+dx, 495, 20+dx, 495, 20+dx, 60, 25+dx, 60)
	love.graphics.print('Cargo', 30+dx, 55)
	love.graphics.print('Commodity', 30+dx, 75)
	love.graphics.printf('Quant', 140+dx, 75, 100, 'right')
	for n,o in pairs(player.cargo) do
		love.graphics.print(o.n, 30+dx, 75 + n * 20)
		love.graphics.printf(o.q, 140+dx, 75 + n * 20, 100, 'right')
		love.graphics.print(o.u, 240+dx, 75 + n * 20)
	end
	if player.docked then
		dx = 520
		love.graphics.line(dx+100, 60, dx+260, 60, dx+260, 495, dx+20, 495, dx+20, 60, dx+25, 60)
		love.graphics.print('Market', dx+30, 55)
		love.graphics.print('Commodity', dx+30, 75)
		love.graphics.printf('Price', dx+80, 75, 100, 'right')
		love.graphics.printf('Quant', dx+140, 75, 100, 'right')
		for n,o in pairs(u.market) do
			love.graphics.print(o.n, dx+30, 75 + n * 20)
			love.graphics.printf(string.format("%.2f",o.p), dx+80, 75 + n * 20, 100, 'right')
			love.graphics.printf(o.q, dx+140, 75 + n * 20, 100, 'right')
			love.graphics.print(o.u, dx+240, 75 + n * 20)
		end
	end
	if player.docked then draw_menu() end
end

function market:keyreleased(key, unicode)

end

function market:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
	local change = 0
	local n = math.floor((y - 75) / 20)
	if u.market[n] then
		local c 
		if x > 260+25 and x < 260+260 then
			if button == 'l' then c = 1
			elseif button == 'r' then c = 10 end
			if player.cargo[n].q >= c then change = c end
		elseif x > 520+25 and x < 520+260 and player.docked then
			if button == 'l' then c = 1
			elseif button == 'r' then c = 10 end
			if u.market[n].q >= c and player.cargo_max - player.cargo_t >= c and player.cash >= c * u.market[n].p then change = -c end
		end
		player.cargo[n].q = player.cargo[n].q - change
		if player.docked then
			u.market[n].q = u.market[n].q + change
			player.cash = player.cash + change * u.market[n].p
		end
		player.cargo_t = 0
		for _,o in pairs (player.cargo) do if o.u == 't' then player.cargo_t = player.cargo_t + o.q end end
		player.cargo_t = player.cargo_t + player.e_passenger_berth * 5 + player.e_energy_bomb * 10
	end
end

equipment = {}
equipment.__index = equipment

function equipment.create()
	local temp = {}
	setmetatable(temp, equipment)
	temp.menu = 'equipment'
	temp.equip_n = 1
	temp.comment = 0
	temp.buy_front = 0 temp.buy_rear = 0 temp.buy_left = 0 temp.buy_right = 0 temp.buy_auto = 0
	temp.ship_equip = {}
	equipment.calc_ship_equip(temp)
	return temp
end

function equipment:update(dt)
	local x, y = love.mouse.getPosition()
	if player.docked and x > 520+25 and x < 520+260 then
		local n = math.floor((y - 75) / 20 + self.equip_n - 1) 
		if n >= self.equip_n and n < self.equip_n + 20 and equip_list[n] and equip_list[n].l < u.tech then self.comment = n end
	else self.comment = 0
	end
end

function equipment:draw()
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.rectangle('fill', 0, 0, w, h)
	love.graphics.setLine(2, 'rough')
	love.graphics.setFont(frontier2)
	love.graphics.setColor(255, 255, 255, 255)
	local dx = 0
	love.graphics.rectangle('line', dx+20, 60, 241, 60)
	love.graphics.print('Cash', dx+30, 75)
	love.graphics.print('Cargo', dx+30, 95)
	love.graphics.printf(string.format("%.2f",player.cash), dx+140, 75, 100, 'right')
	love.graphics.printf(player.cargo_t..' / '..player.cargo_max, dx+140, 95, 100, 'right')	
	love.graphics.rectangle('line', dx+20, 140, 241, 356)
	local quant
	if player.gun_front_max > 0 then
		quant = 0
		if player.gun_front then
			love.graphics.printf(player.gun_front.n, dx+140, 155, 100, 'right')
			quant = player.gun_front.quant
		end
		love.graphics.print('Front Gun '..' ('..quant..' / '..player.gun_front_max..')', dx+30, 155)
	end
	if player.gun_rear_max > 0 then
		quant = 0
		if player.gun_rear then
			love.graphics.printf(player.gun_rear.n, dx+140, 175, 100, 'right')
			quant = player.gun_rear.quant
		end
		love.graphics.print('Rear Gun '..' ('..quant..' / '..player.gun_rear_max..')', dx+30, 175)
	end
	if player.gun_left_max > 0 then
		quant = 0
		if player.gun_left then
			love.graphics.printf(player.gun_left.n, dx+140, 195, 100, 'right')
			quant = player.gun_left.quant
		end
		love.graphics.print('Left Gun '..' ('..quant..' / '..player.gun_left_max..')', dx+30, 195)
	end
	if player.gun_right_max > 0 then
		quant = 0
		if player.gun_right then
			love.graphics.printf(player.gun_right.n, dx+140, 215, 100, 'right')		
			quant = player.gun_right.quant
		end
		love.graphics.print('Right Gun '..' ('..quant..' / '..player.gun_right_max..')', dx+30, 215)
	end
	if player.gun_auto_max > 0 then
		quant = 0
		if player.gun_auto then
			love.graphics.printf(player.gun_auto.n, dx+140, 235, 100, 'right')		
			quant = player.gun_auto.quant
		end
		love.graphics.print('Auto Gun '..' ('..quant..' / '..player.gun_auto_max..')', dx+30, 235)
	end
	love.graphics.setColor(255, 255, 255, 64)
	if self.buy_front > 0  then love.graphics.rectangle('fill', dx+20, 155, 241, 15) end
	if self.buy_rear > 0  then love.graphics.rectangle('fill', dx+20, 175, 241, 15) end
	if self.buy_left > 0  then love.graphics.rectangle('fill', dx+20, 195, 241, 15) end
	if self.buy_right > 0  then love.graphics.rectangle('fill', dx+20, 215, 241, 15) end
	if self.buy_auto > 0  then love.graphics.rectangle('fill', dx+20, 235, 241, 15) end
	love.graphics.setColor(255, 255, 255, 255)

	if player.missiles_max > 0 then
		love.graphics.print('Missiles '..' ('..player.missiles..' / '..player.missiles_max..')', dx+30, 275)	
	end
	if player.mines_max > 0 then
		love.graphics.print('Mines '..' ('..player.mines..' / '..player.mines_max..')', dx+30, 295)
	end
	if self.comment > 0 then
		love.graphics.printf(equip_list[self.comment].n, 30, 335, 210, "left")
		love.graphics.printf(equip_list[self.comment].comment, 30, 355, 210, "left")
	end
	dx = 260
	love.graphics.line(dx+100, 60, dx+260, 60, dx+260, 495, dx+20, 495, dx+20, 60, dx+25, 60)
	love.graphics.print('Equipment', dx+30, 55)
	love.graphics.print('Item', dx+30, 75)
	for n,o in pairs(self.ship_equip) do
		love.graphics.print(o, dx+30, 75 + n * 20)
	end
	if player.docked then
		dx = 520
		love.graphics.line(dx+100, 60, dx+260, 60, dx+260, 495, dx+20, 495, dx+20, 60, dx+25, 60)
		love.graphics.print('Market', dx+30, 55)
		love.graphics.print('Item', dx+30, 75)
		love.graphics.printf('Price', dx+140, 75, 100, 'right')
		love.graphics.printf(self.equip_n, dx+80, 55, 20, 'right')
		love.graphics.polygon('fill', dx+100, 60, dx+105, 50, dx+110, 60, dx+105, 70)
		for n = self.equip_n, math.min(#equip_list, self.equip_n + 19) do
			if equip_list[n].n == 'Cargo Bay Extension' then
				if player.e_cargo_bay_extension then equip_list[n].p = 10 * player.cargo_max / 1.5
				else equip_list[n].p = 10 * player.cargo_max end
			end
			if equip_list[n].l < u.tech then				
				love.graphics.print(equip_list[n].n, dx+30, 75 + (n - self.equip_n + 1) * 20)
				love.graphics.printf(string.format("%.2f", equip_list[n].p), dx+140, 75 + (n - self.equip_n + 1) * 20, 100, 'right')
			end
		end
	end
	if player.docked then draw_menu() end
end

function equipment:keyreleased(key, unicode)
	if key == 'up' then self.equip_n = math.max(1, self.equip_n - 1)
	elseif key == 'down' then self.equip_n = math.min(#equip_list - 19, self.equip_n + 1) end
end

function equipment:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
	if not player.docked then return end
	if button == 'l' and x > 25 and x < 260 then
		local n = math.floor((y - 135) / 20)
		if not self:buy_gun(n) then self:sell_gun(n) end
		self.buy_front = 0 self.buy_rear = 0 self.buy_left = 0 self.buy_right = 0 self.buy_auto = 0
	elseif button == 'l' and x > 260+25 and x < 260+260 then
		local n = math.floor((y - 75) / 20)
		if self.ship_equip[n] then self:sell_equipment(self.ship_equip[n]) end
		self.buy_front = 0 self.buy_rear = 0 self.buy_left = 0 self.buy_right = 0 self.buy_auto = 0
	elseif button == 'l' and x > 520+25 and x < 520+260 then
		local n = math.floor((y - 75) / 20 + self.equip_n - 1) 
		self.buy_front = 0 self.buy_rear = 0 self.buy_left = 0 self.buy_right = 0 self.buy_auto = 0
		if n >= self.equip_n and n < self.equip_n + 20 and equip_list[n] and equip_list[n].l < u.tech then self:buy_equipment(n) end
	end
	self:calc_ship_equip()
end

function equipment:buy_equipment(index)
	local n, p = equip_list[index].n, equip_list[index].p
	if n == 'Fuel' then
		if player.cash >= math.min(10, player.fuel_max - player.fuel) * p then
			player.fuel = player.fuel + math.min(10, player.fuel_max - player.fuel)
			player.cash = player.cash - math.min(10, player.fuel_max - player.fuel) * p
		end
		return
	end
	if n:find('Missile') then
		if player.missiles < player.missiles_max and player.cash >= p then
			if n == 'Mk I Missile' then player.missiles_mk1 = player.missiles_mk1 + 1
			elseif n == 'Mk II Missile' then player.missiles_mk2 = player.missiles_mk2 + 1
			elseif n == 'Mk III Missile' then player.missiles_mk3 = player.missiles_mk3 + 1
			elseif n == 'ECM Hardened Missile' then player.ecm_missiles = player.ecm_missiles + 1 end
			player.missiles = player.missiles + 1
			player.cash = player.cash - p
		end
		return
	end
	if n:find('Mine') then
		if player.mines < player.mines_max and player.cash >= p then
			if n == 'Mk I Mine' then player.mines_mk1 = player.mines_mk1 + 1
			elseif n == 'Mk II Mine' then player.mines_mk2 = player.mines_mk2 + 1
			elseif n == 'Mk III Mine' then player.mines_mk3 = player.mines_mk3 + 1 end
			player.mines = player.mines + 1
			player.cash = player.cash - p
		end
		return
	end
	if n =='Passenger Berth' then
		if player.cargo_t < player.cargo_max - 4 and player.cash >= p then
			player.e_passenger_berth = player.e_passenger_berth + 1
			player.cash = player.cash - p
			player.cargo_t = player.cargo_t + 5
		end
		return
	end
	if n =='Energy Bomb' then
		if player.cargo_t < player.cargo_max - 9 and player.cash >= p then
			player.e_energy_bomb = player.e_energy_bomb + 1
			player.cash = player.cash - p
			player.cargo_t = player.cargo_t + 10
		end
		return
	end
	if n:find('Phaser') or n:find('Laser') then
		if player.cash >= p then
			if player.gun_front_max > 0 and (player.gun_front == nil or (player.gun_front.quant < player.gun_front_max and player.gun_front.n == n)) then self.buy_front = index end
			if player.gun_rear_max > 0 and (player.gun_rear == nil or (player.gun_rear.quant < player.gun_rear_max and player.gun_rear.n == n)) then self.buy_rear = index end
			if player.gun_left_max > 0 and (player.gun_left == nil or (player.gun_left.quant < player.gun_left_max and player.gun_left.n == n)) then self.buy_left = index end
			if player.gun_right_max > 0 and (player.gun_right == nil or (player.gun_right.quant < player.gun_right_max and player.gun_right.n == n)) then self.buy_right = index end
			if player.gun_auto_max > 0 and (player.gun_auto == nil or (player.gun_auto.quant < player.gun_auto_max and player.gun_auto.n == n)) then self.buy_auto = index end
		end
		return
	end
	for _,o in pairs(self.ship_equip) do
		if n:sub(1,5) == o:sub(1,5) then return end
	end
	if player.cash >= p then
		if n == 'Hyperspace Engine Mk I' then player.e_hyperspace = 1
		elseif n == 'Hyperspace Engine Mk II' then player.e_hyperspace = 2
		elseif n == 'Hyperspace Engine Mk III' then player.e_hyperspace = 3 end
		if n == 'Cargo Bay Extension' then
			if player.cargo_t == 0 then 
				player.e_cargo_bay_extension = true
				player.cargo_max = player.cargo_max * 1.5
			else return end
		end
		if n == 'Communication System' then player.e_comm_system = true end
		if n == 'Autopilot Mk I' then player.e_autopilot = 1
		elseif n == 'Autopilot Mk II' then player.e_autopilot = 2
		elseif n == 'Autopilot Mk III' then player.e_autopilot = 3 end
		if n == 'Scanner Mk I' then player.e_scanner = 1 u.scanner_range = 1
		elseif n == 'Scanner Mk II' then player.e_scanner = 2 u.scanner_range = 2.5
		elseif n == 'Scanner Mk III' then player.e_scanner = 3 u.scanner_range = 5
		elseif n == 'Scanner Mk IV' then player.e_scanner = 4 u.scanner_range = 10 end
		if n == 'Hull Booster' then player.e_hull_booster = true end
		if n == 'ECM System' then player.e_ecm_system = true end
		if n == 'Fuel Injectors' then player.e_turbo = true end
		if n == 'Scoops' then player.e_scoops = true end
		if n == 'Targeting System' then player.e_targeting_system = true end
		if n == 'Fuel Collector' then player.e_fuel_collector = true end
		if n == 'Auto-Aim System' then player.e_auto_aim = true end
		if n == 'Tractor Beam' then player.e_tractor_beam = true end
		player.cash = player.cash - p
	end
end

function equipment:sell_equipment(n)
	for _,o in pairs(equip_list) do
		if n:find(o.n) and o.l < u.tech then
			if n:find('Hyperspace') then player.e_hyperspace = 0 end
			if n:find('Autopilot') then player.e_autopilot = 0 end
			if n:find('Scanner') then player.e_scanner = 0 u.scanner_range = 0 end
			if n:find('Energy Bomb') then
				player.e_energy_bomb = player.e_energy_bomb - 1
				player.cargo_t = player.cargo_t - 10
			end
			if n:find('Missile') then
				if n:find('Mk I Missile') then player.missiles_mk1 = player.missiles_mk1 - 1 end
				if n:find('Mk II Missile') then player.missiles_mk2 = player.missiles_mk2 - 1 end
				if n:find('Mk III Missile') then player.missiles_mk3 = player.missiles_mk3 - 1 end
				if n:find('ECM Hardened Missile') then player.ecm_missiles = player.ecm_missiles - 1 end
				player.missiles = player.missiles - 1
			end
			if n:find('Mine') then
				if n:find('Mk I Mine') then player.mines_mk1 = player.mines_mk1 - 1 end
				if n:find('Mk II Mine') then player.mines_mk2 = player.mines_mk2 - 1 end
				if n:find('Mk III Mine') then player.mines_mk3 = player.mines_mk3 - 1 end
				player.mines = player.mines - 1
			end
			if n:find('Passenger Berth') then
				player.e_passenger_berth = player.e_passenger_berth - 1
				player.cargo_t = player.cargo_t - 5
			end
			if n == 'Cargo Bay Extension' then
				if player.cargo_t == 0 then
					player.e_cargo_bay_extension = false
					player.cargo_max = player.cargo_max / 1.5
				else return end
			end
			if n == 'Communication System' then player.e_comm_system = false end
			if n == 'Hull Booster' then player.e_hull_booster = false end
			if n == 'ECM System' then player.e_ecm_system = false end
			if n == 'Fuel Injectors' then player.e_turbo = false end
			if n == 'Scoops' then player.e_scoops = false end
			if n == 'Targeting System' then player.e_targeting_system = false end
			if n == 'Fuel Collector' then player.e_fuel_collector = false end
			if n == 'Auto-Aim System' then player.e_auto_aim = false end
			if n == 'Tractor Beam' then player.e_tractor_beam = false end
			player.cash = player.cash + o.p / 2
		end 
	end
end

function equipment:buy_gun(n)
	if n == 1 and self.buy_front > 0 then
		if player.gun_front == nil then 
			if equip_list[self.buy_front].n:find('Phaser') then player.gun_front = phaser(player, equip_list[self.buy_front].n, 'front', 1)
			else player.gun_front = laser(player, equip_list[self.buy_front].n, 'front', 1) end
		else player.gun_front.quant = player.gun_front.quant + 1 end
		player.cash = player.cash - equip_list[self.buy_front].p
		return true
	elseif n == 2 and self.buy_rear > 0 then
		if player.gun_rear == nil then 
			if equip_list[self.buy_rear].n:find('Phaser') then player.gun_rear = phaser(player, equip_list[self.buy_rear].n, 'rear', 1)
			else player.gun_rear = laser(player, equip_list[self.buy_rear].n, 'rear', 1) end
		else player.gun_rear.quant = player.gun_rear.quant + 1 end
		player.cash = player.cash - equip_list[self.buy_rear].p
		return true
	elseif n == 3 and self.buy_left > 0 then
		if player.gun_left == nil then 
			if equip_list[self.buy_left].n:find('Phaser') then player.gun_left = phaser(player, equip_list[self.buy_left].n, 'left', 1)
			else player.gun_left = laser(player, equip_list[self.buy_left].n, 'left', 1) end
		else player.gun_left.quant = player.gun_left.quant + 1 end
		player.cash = player.cash - equip_list[self.buy_left].p
		return true
	elseif n == 4 and self.buy_right > 0 then
		if player.gun_right == nil then 
			if equip_list[self.buy_right].n:find('Phaser') then player.gun_right = phaser(player, equip_list[self.buy_right].n, 'right', 1)
			else player.gun_right = laser(player, equip_list[self.buy_right].n, 'right', 1) end
		else player.gun_right.quant = player.gun_right.quant + 1 end
		player.cash = player.cash - equip_list[self.buy_right].p
		return true
	elseif n == 5 and self.buy_auto > 0 then
		if player.gun_auto == nil then 
			if equip_list[self.buy_auto].n:find('Phaser') then player.gun_auto = phaser(player, equip_list[self.buy_auto].n, 'auto', 1)
			else player.gun_auto = laser(player, equip_list[self.buy_auto].n, 'auto', 1) end
		else player.gun_auto.quant = player.gun_auto.quant + 1 end
		player.cash = player.cash - equip_list[self.buy_auto].p
		return true
	end
	return false
end

function equipment:sell_gun(n)
	if n == 1 then
		for _,o in pairs(equip_list) do
			if player.gun_front and o.n == player.gun_front.n and o.l < u.tech then
				player.cash = player.cash + o.p / 2
				if player.gun_front.quant == 1 then player.gun_front = nil
				else player.gun_front.quant = player.gun_front.quant - 1 end
			end
		end
	elseif n == 2 then
		for _,o in pairs(equip_list) do
			if player.gun_rear and o.n == player.gun_rear.n and o.l < u.tech then
				player.cash = player.cash + o.p / 2
				if player.gun_rear.quant == 1 then player.gun_rear = nil
				else player.gun_rear.quant = player.gun_rear.quant - 1 end
			end
		end
	elseif n == 3 then 
		for _,o in pairs(equip_list) do
			if player.gun_left and o.n == player.gun_left.n and o.l < u.tech then
				player.cash = player.cash + o.p / 2
				if player.gun_left.quant == 1 then player.gun_left = nil
				else player.gun_left.quant = player.gun_front.left - 1 end
			end
		end
	elseif n == 4 then
		for _,o in pairs(equip_list) do
			if player.gun_right and o.n == player.gun_right.n and o.l < u.tech then
				player.cash = player.cash + o.p / 2
				if player.gun_right.quant == 1 then player.gun_right = nil
				else player.gun_right.quant = player.gun_right.quant - 1 end
			end
		end
	end 
end

function equipment:calc_ship_equip()
	self.ship_equip = {}
	if player.missiles_mk1 == 1 then table.insert(self.ship_equip, '1 Mk I Missile')
	elseif player.missiles_mk1 > 1 then table.insert(self.ship_equip, player.missiles_mk1..' Mk I Missiles') end
	if player.missiles_mk2 == 1 then table.insert(self.ship_equip, '1 Mk II Missile')
	elseif player.missiles_mk2 > 1 then table.insert(self.ship_equip, player.missiles_mk2..' Mk II Missiles') end
	if player.missiles_mk3 == 1 then table.insert(self.ship_equip, '1 Mk III Missile')
	elseif player.missiles_mk3 > 1 then table.insert(self.ship_equip, player.missiles_mk3..' Mk III Missiles') end
	if player.ecm_missiles == 1 then table.insert(self.ship_equip, 'ECM Hardened Missile')
	elseif player.ecm_missiles > 1 then table.insert(self.ship_equip, player.ecm_missiles..' ECM Hardened Missiles') end
	if player.mines_mk1 == 1 then table.insert(self.ship_equip, '1 Mk I Mine')
	elseif player.mines_mk1 > 1 then table.insert(self.ship_equip, player.mines_mk1..' Mk I Mines') end
	if player.mines_mk2 == 1 then table.insert(self.ship_equip, '1 Mk II Mine')
	elseif player.mines_mk2 > 1 then table.insert(self.ship_equip, player.mines_mk2..' Mk II Mines') end
	if player.mines_mk3 == 1 then table.insert(self.ship_equip, '1 Mk III Mine')
	elseif player.mines_mk3 > 1 then table.insert(self.ship_equip, player.mines_mk3..' Mk III Mines') end
	if player.e_energy_bomb == 1 then table.insert(self.ship_equip, '1 Energy Bomb')
	elseif player.e_energy_bomb > 1 then table.insert(self.ship_equip, player.e_energy_bomb..' Energy Bombs') end
	if player.e_passenger_berth == 1 then table.insert(self.ship_equip, '1 Passenger Berth')
	elseif player.e_passenger_berth > 1 then table.insert(self.ship_equip, player.e_passenger_berth..' Passenger Berths') end
	if player.e_scanner == 1 then table.insert(self.ship_equip, 'Scanner Mk I')
	elseif player.e_scanner == 2 then table.insert(self.ship_equip, 'Scanner Mk II')
	elseif player.e_scanner == 3 then table.insert(self.ship_equip, 'Scanner Mk III')
	elseif player.e_scanner == 4 then table.insert(self.ship_equip, 'Scanner Mk VI') end
	if player.e_hyperspace == 1 then table.insert(self.ship_equip, 'Hyperspace Engine Mk I')
	elseif player.e_hyperspace == 2 then table.insert(self.ship_equip, 'Hyperspace Engine Mk II')
	elseif player.e_hyperspace == 3 then table.insert(self.ship_equip, 'Hyperspace Engine Mk III') end
	if player.e_autopilot == 1 then table.insert(self.ship_equip, 'Autopilot Mk I')
	elseif player.e_autopilot == 2 then table.insert(self.ship_equip, 'Autopilot Mk II')
	elseif player.e_autopilot == 3 then table.insert(self.ship_equip, 'Autopilot Mk III') end
	if player.e_comm_system then table.insert(self.ship_equip, 'Communication System') end
	if player.e_cargo_bay_extension then table.insert(self.ship_equip, 'Cargo Bay Extension') end
	if player.e_hull_booster then table.insert(self.ship_equip, 'Hull Booster') end
	if player.e_ecm_system then table.insert(self.ship_equip, 'ECM System') end
	if player.e_turbo then table.insert(self.ship_equip, 'Fuel Injectors') end
	if player.e_scoops then table.insert(self.ship_equip, 'Scoops') end
	if player.e_targeting_system then table.insert(self.ship_equip, 'Targeting System') end
	if player.e_fuel_collector then table.insert(self.ship_equip, 'Fuel Collector') end
	if player.e_auto_aim then table.insert(self.ship_equip, 'Auto-Aim System') end
end

ships = {}
ships.__index = ships

function ships.create()
	local temp = {}
	setmetatable(temp, ships)
	temp.menu = 'ships'
	temp.ships_list = {}
	temp.ships_n = 1
	ships.load_ships(temp)
	return temp
end

function ships:load_ships()
	local aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = adder()
	table.insert(self.ships_list, {model = 'Adder', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = asp()
	table.insert(self.ships_list, {model = 'Asp', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = gecko()
	table.insert(self.ships_list, {model = 'Gecko', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = boa()
	table.insert(self.ships_list, {model = 'Boa', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = cobra()
	table.insert(self.ships_list, {model = 'Cobra', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = spearhead()
	table.insert(self.ships_list, {model = 'Spearhead', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = python()
	table.insert(self.ships_list, {model = 'Python', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
	aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max,
	particlelife, r, g, b, tech = anaconda()
	table.insert(self.ships_list, {model = 'Anaconda', aa = aa, a_max = a_max, v_max = v_max, turn = turn, img = img, scale = scale, fuel_delta = fuel_delta, fuel_max = fuel_max,
	hull_delta = hull_delta, hull_max = hull_max, cargo_max = cargo_max, missiles_max = missiles_max, mines_max = mines_max,
	gun_front_max = gun_front_max, gun_rear_max = gun_rear_max, gun_left_max = gun_left_max, gun_right_max = gun_right_max, gun_auto_max = gun_auto_max,
	tech = tech})
end

function ships:update(dt)

end

function ships:draw()
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.rectangle('fill', 0, 0, w, h)
	love.graphics.setLine(2, 'rough')
	love.graphics.setFont(frontier2)
	love.graphics.setColor(255, 255, 255, 255)
	local dx = 0
	love.graphics.rectangle('line', dx+20, 60, 241, 60)
	love.graphics.print('Cash', dx+30, 75)
	love.graphics.print('Cargo', dx+30, 95)
	love.graphics.printf(string.format("%.2f",player.cash), dx+140, 75, 100, 'right')
	love.graphics.printf(player.cargo_t..' / '..player.cargo_max, dx+140, 95, 100, 'right')	
	love.graphics.rectangle('line', dx+20, 140, 241, 356)
	dx = 260
	love.graphics.line(dx+100, 60, dx+260+260, 60, dx+260+260, 495, dx+20, 495, dx+20, 60, dx+25, 60)
	love.graphics.print('Ships', dx+30, 55)
	love.graphics.printf(self.ships_n, dx+80, 55, 20, 'right')
	love.graphics.polygon('fill', dx+100, 60, dx+105, 50, dx+110, 60, dx+105, 70)

	for n,o in pairs(self.ships_list) do
		if o.tech < u.tech and n - self.ships_n >= 0 and n - self.ships_n < 4 then
	--aa, a_max, v_max, turn, img, scale, fuel_delta, fuel_max,
	--hull_delta, hull_max, cargo_max, missiles_max, mines_max,
	--gun_front_max, gun_rear_max, gun_left_max, gun_right_max, gun_auto_max, tech
			love.graphics.print('Model: '..o.model, dx+30, 75 + (n - self.ships_n) * 105)
			love.graphics.print('Turn rate: '..o.turn, dx+120, 75 + (n - self.ships_n) * 105)
			love.graphics.print('Accel ratio: '..o.aa, dx+210, 75 + (n - self.ships_n) * 105)
			love.graphics.print('Max accel: '..o.aa, dx+300, 75 + (n - self.ships_n) * 105)
			love.graphics.print('Max vel: '..o.v_max, dx+30, 95 + (n - self.ships_n) * 105)
			love.graphics.print('Fuel delta: '..o.fuel_delta, dx+120, 95 + (n - self.ships_n) * 105)
			love.graphics.print('Fuel: '..o.fuel_max, dx+210, 95 + (n - self.ships_n) * 105)
			love.graphics.print('Hull rec.: '..o.hull_delta, dx+300, 95 + (n - self.ships_n) * 105)
			love.graphics.print('Hull: '..o.hull_max, dx+30, 115 + (n - self.ships_n) * 105)
			love.graphics.print('Cargo: '..o.cargo_max, dx+120, 115 + (n - self.ships_n) * 105)
			love.graphics.print('Missiles: '..o.missiles_max, dx+210, 115 + (n - self.ships_n) * 105)
			love.graphics.print('Mines: '..o.mines_max, dx+300, 115 + (n - self.ships_n) * 105)
			love.graphics.print('Front guns: '..o.gun_front_max, dx+30, 135 + (n - self.ships_n) * 105)
			love.graphics.print('Rear guns: '..o.gun_rear_max, dx+120, 135 + (n - self.ships_n) * 105)
			love.graphics.print('Left guns: '..o.gun_left_max, dx+210, 135 + (n - self.ships_n) * 105)
			love.graphics.print('Right guns: '..o.gun_right_max, dx+300, 135 + (n - self.ships_n) * 105)
			love.graphics.print('Tech level: '..o.tech + 1, dx+30, 155 + (n - self.ships_n) * 105)
			love.graphics.draw(o.img, dx + 450, 115 + (n - self.ships_n) * 105, 0, o.scale, o.scale, o.img:getHeight()/2, o.img:getHeight()/2)
		end
	end
	if player.docked then draw_menu() end
end

function ships:keyreleased(key, unicode)
	if key == 'up' then self.ships_n = math.max(1, self.ships_n - 1)
	elseif key == 'down' then self.ships_n = math.min(#self.ships_list - 3, self.ships_n + 1) end
end

function ships:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
end

billboard = {}
billboard.__index = billboard

function billboard.create()
	local temp = {}
	setmetatable(temp, billboard)
	temp.menu = 'billboard'
	return temp
end

function billboard:update(dt)

end

function billboard:draw()
	if player.docked then draw_menu() end
end

function billboard:keyreleased(key, unicode)

end

function billboard:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
end

options = {}
options.__index = options

function options.create()
	local temp = {}
	setmetatable(temp, options)
	temp.files_n = 1
	temp.option = ''
	--save load keyboard configuration acknowledge
	temp.save_success = false
	temp.games = {}
	temp.menu = 'options'
	if not love.filesystem.isFile("games.save") then
		local file = love.filesystem.newFile("games.save")
		file:open('w')
		file:close()
	end
	return temp
end

function options:update(dt)

end

function options:draw()
	local dx = 0
	love.graphics.setColor(0, 0, 0, 128 + 64)
	love.graphics.rectangle('fill', 0, 0, w, h)
	love.graphics.setLine(2, 'rough')
	love.graphics.setFont(frontier2)
	if self.option == 'save' then
		love.graphics.setColor(128, 128, 128, 128)
		love.graphics.rectangle('fill', dx+20, 60, 241, 60)
		dx = 260
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.line(dx+25, 60, dx+260, 60, dx+260, 495, dx+20, 495, dx+20, 60, dx+25, 60)
		if self.save_success then love.graphics.print('Game Saved', dx+30, 75)
		else love.graphics.print('Save Game Failed', dx+30, 75) end
	elseif self.option == 'load' then
		love.graphics.setColor(128, 128, 128, 128)
		love.graphics.rectangle('fill', dx+20, 120, 241, 60)
		dx = 260
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.line(dx+100, 60, dx+260, 60, dx+260, 495, dx+20, 495, dx+20, 60, dx+25, 60)
		love.graphics.print('Games', dx+30, 55)
		love.graphics.printf(self.files_n, dx+80, 55, 20, 'right')
		love.graphics.polygon('fill', dx+100, 60, dx+105, 50, dx+110, 60, dx+105, 70)
		for n = self.files_n, math.min(#self.games, self.files_n + 19) do
			love.graphics.print(self.games[n].n, dx+30, 55 + (n - self.files_n + 1) * 20)
		end
	elseif self.option == 'keyboard' then
		love.graphics.setColor(128, 128, 128, 128)
		love.graphics.rectangle('fill', dx+20, 180, 241, 60)
	elseif self.option == 'configuration' then
		love.graphics.setColor(128, 128, 128, 128)
		love.graphics.rectangle('fill', dx+20, 240, 241, 60)
	elseif self.option == 'acknowledge' then
		love.graphics.setColor(128, 128, 128, 128)
		love.graphics.rectangle('fill', dx+20, 300, 241, 60)
	end
	if player.docked then

	end
	dx = 0
	love.graphics.setColor(255, 255, 255, 255)
	if player.docked then
		love.graphics.rectangle('line', dx+20, 60, 241, 60)
		love.graphics.printf('Save Game', dx+90, 85, 100, 'center')
	end
	love.graphics.rectangle('line', dx+20, 120, 241, 60)
	love.graphics.printf('Load Game', dx+90, 85+60, 100, 'center')
	love.graphics.rectangle('line', dx+20, 180, 241, 60)
	love.graphics.printf('Keyboard', dx+90, 85+120, 100, 'center')
	love.graphics.rectangle('line', dx+20, 240, 241, 60)
	love.graphics.printf('Configuration', dx+90, 85+180, 100, 'center')
	love.graphics.rectangle('line', dx+20, 300, 241, 60)
	love.graphics.printf('Acknowledge', dx+90, 85+240, 100, 'center')
	love.graphics.rectangle('line', dx+20, 360, 241, 60)
	love.graphics.printf('Exit Game', dx+90, 85+300, 100, 'center')
	if player.docked then draw_menu() end
end

function options:keyreleased(key, unicode)
	if self.option == 'load' then
		if key == 'up' then self.files_n = math.max(1, self.files_n - 1)
		elseif key == 'down' then self.files_n = math.min(20, self.files_n + 1) end
	end
end

function options:mousepressed(x, y, button)
	if mousepressed_menu(x, y, button) then return end
	if button == 'l' and x > 25 and x < 260 then
		local n = math.floor(y / 60)
		if n == 1 then
			self.option = 'save'
			self:load_from_file()
			self.save_success = self:save_game()
		elseif n == 2 then
			self.option = 'load'
			self:load_from_file()
		elseif n == 3 then self.option = 'keyboard'
		elseif n == 4 then self.option = 'configuration'
		elseif n == 5 then self.option = 'acknowledge'
		elseif n == 6 then love.event.push('q')
		end
	end
	if self.option == 'load' then
		if x > 260+25 and x < 260+260 then
			local n = math.floor((y - 55) / 20 + self.files_n - 1)
			if button == 'l' then
				if n >= self.files_n and n <= #self.games then loadstring(self.games[n].command)() end 
			elseif button == 'r' then
				if n >= self.files_n and n <= #self.games then table.remove(self.games, n) end
				self:save_to_file()
			end
		end
	end
end

function options:save_game()
	local s1, s2
	s1 = u.commander..', '..u.galaxy[u.ss].ss_name..', '..string.format("%.5f", u.time / 100000)
	s2 = 'u.commander='..("%q"):format(u.commander)
	s2 = s2..' u.time='..u.time
	s2 = s2..' u.ss='..u.ss
	s2 = s2..' u:create_ss('..u.ss..',0,0)'
	s2 = s2..' u.scanner_range='..u.scanner_range
	s2 = s2..' while #u.obj > 1 do table.remove(u.obj) end'
	for n = 1, #u.planets do
		s2 = s2..' u.planets['..n..'].pos=vector('..u.planets[n].pos.x..','..u.planets[n].pos.y..')'
		s2 = s2..' u.planets['..n..'].angle='..u.planets[n].angle
		if u.obj[n] then
			if     u.obj[n].type == 'space_station' then s2 = s2..' u.obj['..n..']=space_station('..n..')'
			elseif u.obj[n].type == 'ground_station' then s2 = s2..' u.obj['..n..']=ground_station('..n..')'
			elseif u.obj[n].type == 'ring_station' then s2 = s2..' u.obj['..n..']=ring_station('..n..')'
			end
		end
	end
	s2 = s2..' u.ast_fields={}'
	for n = 1, #u.ast_fields do
		s2 = s2..' table.insert(u.ast_fields,{pos=vector('..u.ast_fields[n].pos.x..','..u.ast_fields[n].pos.y..'),r='..u.ast_fields[n].r..',render=false})'
	end
	s2 = s2..' u.market='..Serialize(u.market)
	s2 = s2..' player.cargo='..Serialize(player.cargo)
	s2 = s2..' player.pos=vector('..player.pos.x..','..player.pos.y..')'
	s2 = s2..' player.hull='..player.hull
	s2 = s2..' player.fuel='..player.fuel
	s2 = s2..' player.name='..("%q"):format(player.name)
	s2 = s2..' player.status='..("%q"):format(player.status)
	s2 = s2..' player.cargo_t='..player.cargo_t
	s2 = s2..' player.cargo_max='..player.cargo_max
	s2 = s2..' player.cash='..player.cash
	s2 = s2..' player.color='..Serialize(player.color)
	s2 = s2..' player.e_hyperspace='..player.e_hyperspace
	s2 = s2..' player.e_autopilot='..player.e_autopilot
	s2 = s2..' player.e_scanner='..player.e_scanner
	s2 = s2..' player.e_passenger_berth='..player.e_passenger_berth
	s2 = s2..' player.e_energy_bomb='..player.e_energy_bomb
	s2 = s2..' player.e_cargo_bay_extension='..(player.e_cargo_bay_extension and "true" or "false")
	s2 = s2..' player.e_comm_system='..(player.e_comm_system and "true" or "false")
	s2 = s2..' player.e_hull_booster='..(player.e_hull_booster and "true" or "false")
	s2 = s2..' player.e_ecm_system='..(player.e_ecm_system and "true" or "false")
	s2 = s2..' player.e_turbo='..(player.e_turbo and "true" or "false")
	s2 = s2..' player.e_scoops='..(player.e_scoops and "true" or "false")
	s2 = s2..' player.e_targeting_system='..(player.e_targeting_system and "true" or "false")
	s2 = s2..' player.e_fuel_collector='..(player.e_fuel_collector and "true" or "false")
	s2 = s2..' player.e_auto_aim='..(player.e_auto_aim and "true" or "false")
	s2 = s2..' player.missiles_mk1='..player.missiles_mk1
	s2 = s2..' player.missiles_mk2='..player.missiles_mk2
	s2 = s2..' player.missiles_mk3='..player.missiles_mk3
	s2 = s2..' player.ecm_missiles='..player.ecm_missiles
	s2 = s2..' player.missiles='..player.missiles
	s2 = s2..' player.mines='..player.mines
	s2 = s2..' player.mines_mk1='..player.mines_mk1
	s2 = s2..' player.mines_mk2='..player.mines_mk2
	s2 = s2..' player.mines_mk3='..player.mines_mk3
	if not player.gun_front then s2 = s2..' player.gun_front=nil'
	elseif player.gun_front.n:find('Phaser') then s2 = s2..' player.gun_front=phaser(player,"'..player.gun_front.n..'","front",'..player.gun_front.quant..')'
	elseif player.gun_front.n:find('Laser') then s2 = s2..' player.gun_front=laser(player,"'..player.gun_front.n..'","front",'..player.gun_front.quant..')' end
	if not player.gun_rear then s2 = s2..' player.gun_rear=nil'
	elseif player.gun_rear.n:find('Phaser') then s2 = s2..' player.gun_rear=phaser(player,"'..player.gun_rear.n..'","rear",'..player.gun_rear.quant..')'
	elseif player.gun_rear.n:find('Laser') then s2 = s2..' player.gun_rear=laser(player,"'..player.gun_rear.n..'","rear",'..player.gun_rear.quant..')' end
	if not player.gun_left then s2 = s2..' player.gun_left=nil'
	elseif player.gun_left.n:find('Phaser') then s2 = s2..' player.gun_left=phaser(player,"'..player.gun_left.n..'","left",'..player.gun_left.quant..')'
	elseif player.gun_left.n:find('Laser') then s2 = s2..' player.gun_left=laser(player,"'..player.gun_left.n..'","left",'..player.gun_left.quant..')' end
	if not player.gun_right then s2 = s2..' player.gun_right=nil'
	elseif player.gun_right.n:find('Phaser') then s2 = s2..' player.gun_right=phaser(player,"'..player.gun_right.n..'","right",'..player.gun_right.quant..')'
	elseif player.gun_right.n:find('Laser') then s2 = s2..' player.gun_right=laser(player,"'..player.gun_right.n..'","right",'..player.gun_right.quant..')' end
	if not player.gun_auto then s2 = s2..' player.gun_auto=nil'
	elseif player.gun_auto.n:find('Phaser') then s2 = s2..' player.gun_auto=phaser(player,"'..player.gun_auto.n..'","auto",'..player.gun_auto.quant..')'
	elseif player.gun_auto.n:find('Laser') then s2 = s2..' player.gun_auto=laser(player,"'..player.gun_auto.n..'","auto",'..player.gun_auto.quant..')' end
	for n, m in pairs(u.obj) do
		if m == player.dock then s2 = s2..' player.dock=u.obj['..n..']' end
	end
	s2 = s2..'u.view = cockpit.create()'
	table.insert(self.games,{n = s1, command = s2})
	return self:save_to_file()
end

function options:save_to_file()
	local s = ''
	for _, n in pairs(self.games) do
		s = s..'table.insert(u.view.games,{n="'..n.n..'",command=\''..n.command..'\'}) '--\n'
	end
	if s ~= '' then s = compress(s) end
	return love.filesystem.write("games.save", s, all)
end

function options:load_from_file()
	self.games = {}
	local s = decompress(love.filesystem.read("games.save",all))
	if s and s:find('table.insert') then loadstring(s)() end
end
